<!--  <tree-select :options="deptTreeList" v-model="userForm.deptId" placeholder="选择组织机构" :TreeProps="deptProps" />
      参数:options   树形结构  例： [{value:'xxx',label:'xxx',children:[]}]
      TreeProps类型  {value:'id',babel:'name',children:'children'}
      最好是 符合elementui类型的树形结构
       -->
<!-- 树状选择器 -->
<script lang="ts">
import type { TreeNode } from 'element-plus/es/components/tree-v2/src/types'
import type { TreeNodeData } from 'element-plus/es/components/tree/src/tree.type'
import type { PropType } from 'vue'
import { defineComponent, nextTick, onMounted, reactive, ref, toRefs, watch } from 'vue'
interface PropsIter {
  value: string
  label: string
  children: string
  disabled?: boolean
}
interface TreeIter {
  id: string
  label: string
  children?: TreeIter[]
}
export default defineComponent({
  props: {
    // 组件绑定的options
    options: {
      type: Array as PropType<TreeIter[]>,
      required: true,
    },
    // 配置选项
    keyProps: Object as PropType<PropsIter>,
    // 双向绑定值
    modelValue: [String, Number],
    // 组件样式宽
    width: {
      type: String,
      default: '240px',
    },
    // 空占位字符
    placeholder: String,
    // eslint-disable-next-line vue/prop-name-casing
    TreeProps: {
      type: Object,
      default: () => { return {} },
    },
  },
  setup(props, { emit }) {
    const { modelValue } = toRefs(props)
    const select: { value: string | number | undefined; currentNodeLabel: string | number | undefined; currentNodeKey: string | number | undefined } = reactive({
      value: modelValue.value,
      currentNodeKey: '',
      currentNodeLabel: '',
    })
    const treeSelect = ref<HTMLElement | null>(null)
    const nodeClick = (data: TreeNodeData, node: TreeNode) => {
      select.currentNodeKey = data.id
      select.currentNodeLabel = data.label || data.name
      select.value = data.id;
      (treeSelect.value as any).blur()
      emit('update:modelValue', select.value)
    }
    // 筛选方法
    const treeV2: any = ref<HTMLElement | null>(null)
    const selectFilter = (query: string) => {
      treeV2.value.filter(query)
    }
    // 筛选方法
    const treeFilter = (query: string, node: TreeNode) => {
      return node.label?.indexOf(query) !== -1
    }
    // 直接清空选择数据
    const clearSelected = () => {
      select.currentNodeKey = ''
      select.currentNodeLabel = ''
      select.value = ''
      emit('update:modelValue', undefined)
    }
    // setCurrent通过select.value 设置下拉选择tree 显示绑定的v-model值
    const setCurrent = () => {
      select.currentNodeKey = select.value
      treeV2.value.setCurrentKey(select.value)
      const data: TreeNodeData | undefined = treeV2.value.getCurrentNode(select.value)
      select.currentNodeLabel = data?.label || data?.name
    }
    // 监听外部清空数据源 清空组件数据
    watch(modelValue, (v) => {
      if (v === undefined && select.currentNodeKey !== '') {
        clearSelected()
      }
      // 动态赋值
      if (v) {
        select.value = v
        setCurrent()
      }
    })
    // 回显数据
    onMounted(async () => {
      await nextTick()
      if (select.value) {
        setCurrent()
      }
    })
    const TreeProps = toRefs(props)
    return {
      treeSelect,
      treeV2,
      // eslint-disable-next-line vue/no-dupe-keys
      TreeProps,
      ...toRefs(select),
      nodeClick,
      selectFilter,
      treeFilter,
      clearSelected,
    }
  },
})
</script>

<template>
  <div class="tree_box" :style="width && { width: width.includes('px') ? width : width }">
    <el-select v-model="value" clearable filterable ref="treeSelect" :placeholder="placeholder || '请选择'"
      :filter-method="selectFilter" @clear="clearSelected">
      <el-option :value="currentNodeKey" :label="currentNodeLabel">
        <el-tree-v2 id="tree_v2" ref="treeV2" :data="options" :props="keyProps || TreeProps"
          :current-node-key="currentNodeKey" default-expand-all @node-click="nodeClick" :expand-on-click-node="false"
          :filter-method="treeFilter"></el-tree-v2>
      </el-option>
    </el-select>
  </div>
</template>

<style lang="scss" scoped>
.tree_box {
  width: 214px;
}

.el-scrollbar .el-scrollbar__view .el-select-dropdown__item {
  height: auto;
  max-height: 274px;
  padding: 0;
  overflow: hidden;
  overflow-y: auto;
}

.el-select-dropdown__item.selected {
  font-weight: normal;
}

ul li :deep(.el-tree .el-tree-node__content) {
  height: auto;
  padding: 0 20px;
}

.el-tree-node__label {
  font-weight: normal;
}

.el-tree :deep(.is-current .el-tree-node__label) {
  color: #409eff;
  font-weight: 700;
}

.el-tree :deep(.is-current .el-tree-node__children .el-tree-node__label) {
  color: #606266;
  font-weight: normal;
}

.selectInput {
  padding: 0 5px;
  box-sizing: border-box;
}

.el-select {
  width: 100% !important;
}
</style>

